<TeXmacs|1.99.2>

<style|<tuple|beamer|english>>

<\body>
  <screens|<\shown>
    \;

    <surround||<page-break><new-page>|<\with|par-mode|center>
      <\with|font-size|1.68|font-shape|long>
        <with|color|red|Relaxed Multiplication>

        using

        the Middle Product
      </with>

      <\with|color|blue>
        <math|\<diamondsuit\><space|-1.2spc>\<diamondsuit\><space|-1.2spc>\<diamondsuit\><space|-1.2spc>\<diamondsuit\><space|-1.2spc>\<diamondsuit\>>
      </with>

      <\name>
        <with|font-size|0.84|by>
      </name>

      <\with|font-size|1.19>
        <\with|font|chancery>
          Joris van der Hoeven
        </with>
      </with>

      <\with|color|blue>
        <math|\<diamondsuit\><space|-1.2spc>\<diamondsuit\><space|-1.2spc>\<diamondsuit\><space|-1.2spc>\<diamondsuit\><space|-1.2spc>\<diamondsuit\>><vspace|1fn>
      </with>

      ISSAC '03

      Philadelphia
    </with>>
  </shown>|<\hidden>
    <with|font-series|bold|font-size|1.19|color|dark
    grey|<block*|<tformat|<cwith|1|-1|1|-1|cell-background|broken
    white>|<twith|table-width|1par>|<cwith|1|1|2|2|cell-hyphen|t>|<cwith|1|1|2|2|cell-bsep|1spc>|<cwith|1|1|2|2|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-lborder|0.5ln>|<cwith|1|-1|1|-1|cell-rborder|0.5ln>|<cwith|1|-1|1|-1|cell-bborder|0.5ln>|<cwith|1|-1|1|-1|cell-tborder|0.5ln>|<cwith|1|1|2|2|cell-hpart|1>|<cwith|1|1|1|1|cell-rborder|0ln>|<cwith|1|1|2|2|cell-lborder|0ln>|<cwith|1|1|2|2|cell-rborder|0ln>|<cwith|1|1|3|3|cell-lborder|0ln>|<cwith|1|1|1|1|cell-valign|c>|<cwith|1|1|3|3|cell-valign|c>|<cwith|1|1|2|2|cell-valign|c>|<cwith|1|1|1|1|cell-vcorrect|n>|<cwith|1|1|3|3|cell-vcorrect|n>|<table|<row|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu1.png|0.2w|0.2h||>>|<cell|<with|font-size|1|<with|color|black|Outline>>>|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu2.png|0.2w|0.2h||>>>>>>>

    \;

    \;

    <\enumerate>
      <\with|color|blue>
        <item>The zealous approach

        <item>The lazy approach

        <item>The relaxed approach

        <item>The middle product

        <item>Relaxed multiplication with a fixed series

        <item>Applications
      </with>
    </enumerate>

    \;
  </hidden>|<\hidden>
    <with|font-series|bold|font-size|1.19|color|dark
    grey|<block*|<tformat|<cwith|1|-1|1|-1|cell-background|broken
    white>|<twith|table-width|1par>|<cwith|1|1|2|2|cell-hyphen|t>|<cwith|1|1|2|2|cell-bsep|1spc>|<cwith|1|1|2|2|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-lborder|0.5ln>|<cwith|1|-1|1|-1|cell-rborder|0.5ln>|<cwith|1|-1|1|-1|cell-bborder|0.5ln>|<cwith|1|-1|1|-1|cell-tborder|0.5ln>|<cwith|1|1|2|2|cell-hpart|1>|<cwith|1|1|1|1|cell-rborder|0ln>|<cwith|1|1|2|2|cell-lborder|0ln>|<cwith|1|1|2|2|cell-rborder|0ln>|<cwith|1|1|3|3|cell-lborder|0ln>|<cwith|1|1|1|1|cell-valign|c>|<cwith|1|1|3|3|cell-valign|c>|<cwith|1|1|2|2|cell-valign|c>|<cwith|1|1|1|1|cell-vcorrect|n>|<cwith|1|1|3|3|cell-vcorrect|n>|<table|<row|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu1.png|0.2w|0.2h||>>|<cell|<with|font-size|1|<with|color|brown|1.
    The zealous approach>>>|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu2.png|0.2w|0.2h||>>>>>>>

    \;

    <subsubsection*|Multiplication of formal power series>

    <with|color|blue|Input :> <math|<left|{><tabular*|<tformat|<table|<row|<cell|f=f<rsub|0>+\<cdots\>+f<rsub|n-1>*z<rsup|n-1>>>|<row|<cell|g=g<rsub|0>+\<cdots\>+g<rsub|n-1>*z<rsup|n-1>>>>>>>

    <with|color|blue|Output :> <math|h=h<rsub|0>+\<cdots\>+h<rsub|n-1>*z<rsup|n-1>=f*g+O(z<rsup|n>)>.<vspace|2fn>

    <subsubsection*|Classical multiplication algorithms>

    <surround||<vspace|1fn>|<\itemize>
      <item>Naive multiplication: <math|O(n<rsup|2>)>.

      <item>Divide & conquer: <math|O<left|(>n<rsup|log<rsub|2> 3><right|)>>.

      <item>F.F.T. multiplication: <math|O(n*log n*log log n)>.
    </itemize>>
  </hidden>|<\hidden>
    <with|font-series|bold|font-size|1.19|color|dark
    grey|<block*|<tformat|<cwith|1|-1|1|-1|cell-background|broken
    white>|<twith|table-width|1par>|<cwith|1|1|2|2|cell-hyphen|t>|<cwith|1|1|2|2|cell-bsep|1spc>|<cwith|1|1|2|2|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-lborder|0.5ln>|<cwith|1|-1|1|-1|cell-rborder|0.5ln>|<cwith|1|-1|1|-1|cell-bborder|0.5ln>|<cwith|1|-1|1|-1|cell-tborder|0.5ln>|<cwith|1|1|2|2|cell-hpart|1>|<cwith|1|1|1|1|cell-rborder|0ln>|<cwith|1|1|2|2|cell-lborder|0ln>|<cwith|1|1|2|2|cell-rborder|0ln>|<cwith|1|1|3|3|cell-lborder|0ln>|<cwith|1|1|1|1|cell-valign|c>|<cwith|1|1|3|3|cell-valign|c>|<cwith|1|1|2|2|cell-valign|c>|<cwith|1|1|1|1|cell-vcorrect|n>|<cwith|1|1|3|3|cell-vcorrect|n>|<table|<row|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu1.png|0.2w|0.2h||>>|<cell|<with|font-size|1|<with|color|brown|2.
    The lazy approach>>>|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu2.png|0.2w|0.2h||>>>>>>>

    <subsubsection*|Principle>

    Consider the power series as flows of coefficients. The coefficients are
    computed one by one and at each step we only perform the strictly
    necessary operations.

    <subsubsection*|Implementation>

    A foral power series <math|f> is an algorithm which takes nothing input
    and outputs its first coefficient <math|f<rsub|0>> and the ``remainder''
    <math|(f-f<rsub|0>)/z>.<vspace|1fn>

    <subsubsection*|Important consequence>

    We compute <math|(f*g)<rsub|n>> as soon as
    <math|f<rsub|0>,\<ldots\>,f<rsub|n>> and
    <math|g<rsub|0>,\<ldots\>,g<rsub|n>> are known. In particular,
    <math|f<rsub|n+1>> and <math|g<rsub|n+1>> may depend on
    <math|(f*g)<rsub|0>,\<ldots\>,(f*g)<rsub|n>>.<vspace|1fn>
  </hidden>|<\hidden>
    <with|font-series|bold|font-size|1.19|color|dark
    grey|<block*|<tformat|<cwith|1|-1|1|-1|cell-background|broken
    white>|<twith|table-width|1par>|<cwith|1|1|2|2|cell-hyphen|t>|<cwith|1|1|2|2|cell-bsep|1spc>|<cwith|1|1|2|2|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-lborder|0.5ln>|<cwith|1|-1|1|-1|cell-rborder|0.5ln>|<cwith|1|-1|1|-1|cell-bborder|0.5ln>|<cwith|1|-1|1|-1|cell-tborder|0.5ln>|<cwith|1|1|2|2|cell-hpart|1>|<cwith|1|1|1|1|cell-rborder|0ln>|<cwith|1|1|2|2|cell-lborder|0ln>|<cwith|1|1|2|2|cell-rborder|0ln>|<cwith|1|1|3|3|cell-lborder|0ln>|<cwith|1|1|1|1|cell-valign|c>|<cwith|1|1|3|3|cell-valign|c>|<cwith|1|1|2|2|cell-valign|c>|<cwith|1|1|1|1|cell-vcorrect|n>|<cwith|1|1|3|3|cell-vcorrect|n>|<table|<row|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu1.png|0.2w|0.2h||>>|<cell|<with|font-size|1|<with|color|black|The
    lazy approach II>>>|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu2.png|0.2w|0.2h||>>>>>>>

    <subsubsection*|Application>

    Computing the exponential <math|g=e<rsup|f>> of a series <math|f> by

    <equation*|g=<big|int>f<rprime|'>*g<vspace|1fn>.>

    <subsubsection*|Disadvantage>

    Impossible to use F.F.T. or divide & conquer multiplication.
  </hidden>|<\hidden>
    <with|font-series|bold|font-size|1.19|color|dark
    grey|<block*|<tformat|<cwith|1|-1|1|-1|cell-background|broken
    white>|<twith|table-width|1par>|<cwith|1|1|2|2|cell-hyphen|t>|<cwith|1|1|2|2|cell-bsep|1spc>|<cwith|1|1|2|2|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-lborder|0.5ln>|<cwith|1|-1|1|-1|cell-rborder|0.5ln>|<cwith|1|-1|1|-1|cell-bborder|0.5ln>|<cwith|1|-1|1|-1|cell-tborder|0.5ln>|<cwith|1|1|2|2|cell-hpart|1>|<cwith|1|1|1|1|cell-rborder|0ln>|<cwith|1|1|2|2|cell-lborder|0ln>|<cwith|1|1|2|2|cell-rborder|0ln>|<cwith|1|1|3|3|cell-lborder|0ln>|<cwith|1|1|1|1|cell-valign|c>|<cwith|1|1|3|3|cell-valign|c>|<cwith|1|1|2|2|cell-valign|c>|<cwith|1|1|1|1|cell-vcorrect|n>|<cwith|1|1|3|3|cell-vcorrect|n>|<table|<row|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu1.png|0.2w|0.2h||>>|<cell|<with|font-size|1|<with|color|brown|3.
    The relaxed approach>>>|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu2.png|0.2w|0.2h||>>>>>>>

    \;

    <\with|par-mode|center>
      <with|color|red|Idea : anticipation <math|\<longrightarrow\>>
      acceleration>
    </with>

    \;

    <center|<tabular*|<tformat|<cwith|1|1|1|-1|cell-valign|t>|<table|<row|<cell|<tabular*|<tformat|<twith|table-valign|C>|<cwith|1|1|1|1|cell-bsep|1spc>|<cwith|2|2|1|1|cell-bsep|1spc>|<table|<row|<cell|<with|color|blue|Naive
    algorithm>>>|<row|<cell|<switch|<\shown>
      <block*|<tformat|<table|<row|<cell|<math|g<rsub|2>>>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|g<rsub|1>>>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|g<rsub|0>>>|<cell|0>|<cell|>|<cell|>>|<row|<cell|<math|\<times\>>>|<cell|<math|f<rsub|0>>>|<cell|<math|f<rsub|1>>>|<cell|<math|f<rsub|2>>>>>>>
    </shown>|<hidden|<block*|<tformat|<twith|table-lsep|0cm>|<twith|table-rsep|0cm>|<twith|table-bsep|0cm>|<twith|table-tsep|0cm>|<table|<row|<cell|<math|g<rsub|2>>>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|g<rsub|1>>>|<cell|1>|<cell|>|<cell|>>|<row|<cell|<math|g<rsub|0>>>|<cell|0>|<cell|1>|<cell|>>|<row|<cell|<math|\<times\>>>|<cell|<math|f<rsub|0>>>|<cell|<math|f<rsub|1>>>|<cell|<math|f<rsub|2>>>>>>>>|<hidden|<block*|<tformat|<table|<row|<cell|<math|g<rsub|2>>>|<cell|2>|<cell|>|<cell|>>|<row|<cell|<math|g<rsub|1>>>|<cell|1>|<cell|2>|<cell|>>|<row|<cell|<math|g<rsub|0>>>|<cell|0>|<cell|1>|<cell|2>>|<row|<cell|<math|\<times\>>>|<cell|<math|f<rsub|0>>>|<cell|<math|f<rsub|1>>>|<cell|<math|f<rsub|2>>>>>>>>|<hidden|<block*|<tformat|<cwith|2|2|2|2|cell-background|pastel
    blue>|<cwith|2|2|3|3|cell-background|pastel
    blue>|<cwith|3|3|3|3|cell-background|pastel
    blue>|<table|<row|<cell|<math|g<rsub|2>>>|<cell|2>|<cell|>|<cell|>>|<row|<cell|<math|g<rsub|1>>>|<cell|1>|<cell|2>|<cell|>>|<row|<cell|<math|g<rsub|0>>>|<cell|0>|<cell|1>|<cell|2>>|<row|<cell|<math|\<times\>>>|<cell|<math|f<rsub|0>>>|<cell|<math|f<rsub|1>>>|<cell|<math|f<rsub|2>>>>>>>>>>>|<row|<cell|>>|<row|<cell|<surround||<vspace|1fn>|<\itemize>
      <item*|0><math|h<rsub|0>=f<rsub|0>*g<rsub|0>>.

      <item*|1><math|h<rsub|1>=<with|color|blue|f<rsub|0>*g<rsub|1>>+<with|color|blue|f<rsub|1>*g<rsub|0>>>.

      <item*|2><math|h<rsub|2>=f<rsub|0>*g<rsub|2>+<with|color|blue|f<rsub|1>*g<rsub|1>>+f<rsub|2>*g<rsub|0>>.
    </itemize>>>>>>>>|<cell|>|<cell|<tabular*|<tformat|<twith|table-valign|C>|<cwith|1|1|1|1|cell-bsep|1spc>|<cwith|2|2|1|1|cell-bsep|1spc>|<table|<row|<cell|<with|color|blue|Relaxed
    algorithm>>>|<row|<cell|<switch|<\shown>
      <block*|<tformat|<table|<row|<cell|<math|g<rsub|2>>>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|g<rsub|1>>>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|g<rsub|0>>>|<cell|0>|<cell|>|<cell|>>|<row|<cell|<math|\<times\>>>|<cell|<math|f<rsub|0>>>|<cell|<math|f<rsub|1>>>|<cell|<math|f<rsub|2>>>>>>>
    </shown>|<hidden|<block*|<tformat|<table|<row|<cell|<math|g<rsub|2>>>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|g<rsub|1>>>|<cell|1>|<cell|1>|<cell|>>|<row|<cell|<math|g<rsub|0>>>|<cell|0>|<cell|1>|<cell|>>|<row|<cell|<math|\<times\>>>|<cell|<math|f<rsub|0>>>|<cell|<math|f<rsub|1>>>|<cell|<math|f<rsub|2>>>>>>>>|<hidden|<block*|<tformat|<table|<row|<cell|<math|g<rsub|2>>>|<cell|2>|<cell|>|<cell|>>|<row|<cell|<math|g<rsub|1>>>|<cell|1>|<cell|1>|<cell|>>|<row|<cell|<math|g<rsub|0>>>|<cell|0>|<cell|1>|<cell|2>>|<row|<cell|<math|\<times\>>>|<cell|<math|f<rsub|0>>>|<cell|<math|f<rsub|1>>>|<cell|<math|f<rsub|2>>>>>>>>|<hidden|<block*|<tformat|<cwith|2|2|2|3|cell-background|pastel
    blue>|<cwith|3|3|3|3|cell-background|pastel
    blue>|<table|<row|<cell|<math|g<rsub|2>>>|<cell|2>|<cell|>|<cell|>>|<row|<cell|<math|g<rsub|1>>>|<cell|1>|<cell|1>|<cell|>>|<row|<cell|<math|g<rsub|0>>>|<cell|0>|<cell|1>|<cell|2>>|<row|<cell|<math|\<times\>>>|<cell|<math|f<rsub|0>>>|<cell|<math|f<rsub|1>>>|<cell|<math|f<rsub|2>>>>>>>>>>>|<row|<cell|<surround||<new-page>|<\itemize>
      <item*|0><math|h<rsub|0>=f<rsub|0>*g<rsub|0>>.

      <item*|1><math|h<rsub|1>=<tabular|<tformat|<cwith|1|1|1|1|cell-lsep|0cm>|<cwith|1|1|1|1|cell-rsep|0cm>|<cwith|1|1|1|1|cell-bsep|0cm>|<cwith|1|1|1|1|cell-tsep|0cm>|<twith|table-valign|T>|<table|<row|<cell|<with|color|blue|(f<rsub|0>+f<rsub|1>)*(g<rsub|0>+g<rsub|1>)>>>|<row|<cell|-f<rsub|0>*g<rsub|0>-<with|color|blue|f<rsub|1>*g<rsub|1>>>>>>>>

      <item*|2><math|h<rsub|2>=f<rsub|0>*g<rsub|2>+<with|color|blue|f<rsub|1>*g<rsub|1>>+f<rsub|2>*g<rsub|0>>.
    </itemize>>>>>>>>>>>>>

    \;
  </hidden>|<\hidden>
    <with|font-series|bold|font-size|1.19|color|dark
    grey|<block*|<tformat|<cwith|1|-1|1|-1|cell-background|broken
    white>|<twith|table-width|1par>|<cwith|1|1|2|2|cell-hyphen|t>|<cwith|1|1|2|2|cell-bsep|1spc>|<cwith|1|1|2|2|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-lborder|0.5ln>|<cwith|1|-1|1|-1|cell-rborder|0.5ln>|<cwith|1|-1|1|-1|cell-bborder|0.5ln>|<cwith|1|-1|1|-1|cell-tborder|0.5ln>|<cwith|1|1|2|2|cell-hpart|1>|<cwith|1|1|1|1|cell-rborder|0ln>|<cwith|1|1|2|2|cell-lborder|0ln>|<cwith|1|1|2|2|cell-rborder|0ln>|<cwith|1|1|3|3|cell-lborder|0ln>|<cwith|1|1|1|1|cell-valign|c>|<cwith|1|1|3|3|cell-valign|c>|<cwith|1|1|2|2|cell-valign|c>|<cwith|1|1|1|1|cell-vcorrect|n>|<cwith|1|1|3|3|cell-vcorrect|n>|<table|<row|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu1.png|0.2w|0.2h||>>|<cell|<with|font-size|1|<with|color|black|Divide
    & conquer algorithm>>>|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu2.png|0.2w|0.2h||>>>>>>>

    \;

    The divide & conquer algorithm is ``essentially relaxed'': the formula
    for <math|h<rsub|k>> only depends on <math|f<rsub|0>,\<ldots\>,f<rsub|k>>
    and <math|g<rsub|0>,\<ldots\>,g<rsub|k>>.<vspace|1fn>

    <subsubsection*|Example : multiplication at order 4>

    <with|font-size|0.84|<\itemize>
      <item><math|h<rsub|0>=f<rsub|0>*g<rsub|0>> ;

      <item><math|h<rsub|1>=(f<rsub|0>+f<rsub|1>)*(g<rsub|0>+g<rsub|1>)-f<rsub|0>*g<rsub|0>-f<rsub|1>*g<rsub|1>>
      ;

      <item><math|h<rsub|2>=(f<rsub|0>+f<rsub|2>)*(g<rsub|0>+g<rsub|2>)-f<rsub|0>*g<rsub|0>-f<rsub|2>*g<rsub|2>>
      ;

      <item><math|h<rsub|3>=(f<rsub|0>+f<rsub|1>+f<rsub|2>+f<rsub|3>)*(g<rsub|0>+g<rsub|1>+g<rsub|2>+g<rsub|3>)-(f<rsub|0><space|0.2spc>+<space|0.2spc>f<rsub|1>)*(g<rsub|0><space|0.2spc>+<space|0.2spc>g<rsub|1>)<space|0.6spc>-<space|0.6spc>(f<rsub|2><space|0.2spc>+<space|0.2spc>f<rsub|3>)*(g<rsub|2><space|0.2spc>+<space|0.2spc>g<rsub|3>)+f<rsub|0>*g<rsub|0>+f<rsub|1>*g<rsub|1>+f<rsub|2>*g<rsub|2>+f<rsub|3>*g<rsub|3>>
      ;

      <item><math|h<rsub|4>=(f<rsub|1>+f<rsub|3>)*(g<rsub|1>+g<rsub|3>)-f<rsub|1>*g<rsub|1>-f<rsub|3>*g<rsub|3>>
      ;<htab|5mm><resize|<surround||<new-page>|<with|par-mode|center|<block*|<tformat|<cwith|3|3|2|3|cell-background|yellow>|<cwith|4|4|3|3|cell-background|yellow>|<cwith|2|2|2|2|cell-background|orange>|<cwith|2|2|4|4|cell-background|orange>|<cwith|4|4|4|4|cell-background|orange>|<cwith|1|1|2|5|cell-background|red>|<cwith|2|4|5|5|cell-background|red>|<cwith|2|2|3|3|cell-background|red>|<cwith|3|3|4|4|cell-background|red>|<twith|table-valign|T>|<table|<row|<cell|<math|g<rsub|3>>>|<cell|3>|<cell|3>|<cell|3>|<cell|3>>|<row|<cell|<math|g<rsub|2>>>|<cell|2>|<cell|3>|<cell|2>|<cell|3>>|<row|<cell|<math|g<rsub|1>>>|<cell|1>|<cell|1>|<cell|3>|<cell|3>>|<row|<cell|<math|g<rsub|0>>>|<cell|0>|<cell|1>|<cell|2>|<cell|3>>|<row|<cell|<math|\<times\>>>|<cell|<math|f<rsub|0>>>|<cell|<math|f<rsub|1>>>|<cell|<math|f<rsub|2>>>|<cell|<math|f<rsub|3>>>>>>>>>||0cm||0.3cm>

      <item><math|h<rsub|5>=(f<rsub|2>+f<rsub|3>)*(g<rsub|2>+g<rsub|3>)-f<rsub|2>*g<rsub|3>-f<rsub|2>*g<rsub|3>>
      ;

      <item><math|h<rsub|6>=f<rsub|3>*g<rsub|3>>.<vspace|1fn>
    </itemize>>

    \;

    Algorithm in time <math|K(n)> and space <math|O(n*log n)>.
  </hidden>|<\hidden>
    <with|font-series|bold|font-size|1.19|color|dark
    grey|<block*|<tformat|<cwith|1|-1|1|-1|cell-background|broken
    white>|<twith|table-width|1par>|<cwith|1|1|2|2|cell-hyphen|t>|<cwith|1|1|2|2|cell-bsep|1spc>|<cwith|1|1|2|2|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-lborder|0.5ln>|<cwith|1|-1|1|-1|cell-rborder|0.5ln>|<cwith|1|-1|1|-1|cell-bborder|0.5ln>|<cwith|1|-1|1|-1|cell-tborder|0.5ln>|<cwith|1|1|2|2|cell-hpart|1>|<cwith|1|1|1|1|cell-rborder|0ln>|<cwith|1|1|2|2|cell-lborder|0ln>|<cwith|1|1|2|2|cell-rborder|0ln>|<cwith|1|1|3|3|cell-lborder|0ln>|<cwith|1|1|1|1|cell-valign|c>|<cwith|1|1|3|3|cell-valign|c>|<cwith|1|1|2|2|cell-valign|c>|<cwith|1|1|1|1|cell-vcorrect|n>|<cwith|1|1|3|3|cell-vcorrect|n>|<table|<row|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu1.png|0.2w|0.2h||>>|<cell|<with|font-size|1|<with|color|black|Fast
    relaxed multiplication>>>|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu2.png|0.2w|0.2h||>>>>>>>

    \;

    <\with|par-mode|center>
      <image|relaxed1.ps|0.6w|0.6h||><vspace|0.5fn>
    </with>

    <math|\<longrightarrow\>><new-page> Relaxed algorithm in time
    <math|O(M(n)*log n)> and space <math|O(n)>.
  </hidden>|<\hidden>
    <with|font-series|bold|font-size|1.19|color|dark
    grey|<block*|<tformat|<cwith|1|-1|1|-1|cell-background|broken
    white>|<twith|table-width|1par>|<cwith|1|1|2|2|cell-hyphen|t>|<cwith|1|1|2|2|cell-bsep|1spc>|<cwith|1|1|2|2|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-lborder|0.5ln>|<cwith|1|-1|1|-1|cell-rborder|0.5ln>|<cwith|1|-1|1|-1|cell-bborder|0.5ln>|<cwith|1|-1|1|-1|cell-tborder|0.5ln>|<cwith|1|1|2|2|cell-hpart|1>|<cwith|1|1|1|1|cell-rborder|0ln>|<cwith|1|1|2|2|cell-lborder|0ln>|<cwith|1|1|2|2|cell-rborder|0ln>|<cwith|1|1|3|3|cell-lborder|0ln>|<cwith|1|1|1|1|cell-valign|c>|<cwith|1|1|3|3|cell-valign|c>|<cwith|1|1|2|2|cell-valign|c>|<cwith|1|1|1|1|cell-vcorrect|n>|<cwith|1|1|3|3|cell-vcorrect|n>|<table|<row|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu1.png|0.2w|0.2h||>>|<cell|<with|font-size|1|<with|color|black|Truncated
    multiplication>>>|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu2.png|0.2w|0.2h||>>>>>>>

    \;

    \;

    <\with|par-mode|center>
      <image|relaxed2.ps|0.666667w|0.666667h||>
    </with>

    \;
  </hidden>|<\hidden>
    <with|font-series|bold|font-size|1.19|color|dark
    grey|<block*|<tformat|<cwith|1|-1|1|-1|cell-background|broken
    white>|<twith|table-width|1par>|<cwith|1|1|2|2|cell-hyphen|t>|<cwith|1|1|2|2|cell-bsep|1spc>|<cwith|1|1|2|2|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-lborder|0.5ln>|<cwith|1|-1|1|-1|cell-rborder|0.5ln>|<cwith|1|-1|1|-1|cell-bborder|0.5ln>|<cwith|1|-1|1|-1|cell-tborder|0.5ln>|<cwith|1|1|2|2|cell-hpart|1>|<cwith|1|1|1|1|cell-rborder|0ln>|<cwith|1|1|2|2|cell-lborder|0ln>|<cwith|1|1|2|2|cell-rborder|0ln>|<cwith|1|1|3|3|cell-lborder|0ln>|<cwith|1|1|1|1|cell-valign|c>|<cwith|1|1|3|3|cell-valign|c>|<cwith|1|1|2|2|cell-valign|c>|<cwith|1|1|1|1|cell-vcorrect|n>|<cwith|1|1|3|3|cell-vcorrect|n>|<table|<row|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu1.png|0.2w|0.2h||>>|<cell|<with|font-size|1|<with|color|brown|4.
    The middle product (HQZ)>>>|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu2.png|0.2w|0.2h||>>>>>>>

    \;

    Given <math|f=f<rsub|0>+\<ldots\>+f<rsub|n-1>*z<rsup|n-1>> and
    <math|g=g<rsub|0>+\<cdots\>+g<rsub|2*n-2>*z<rsup|2*n-2>>, compute
    <math|h=f\<ast\>g=h<rsub|0>+\<cdots\>+h<rsub|n-1>*z<rsup|n-1>> with

    <\equation*>
      h<rsub|i>=<big|sum><rsub|j=0><rsup|n-1>f<rsub|j>*g<rsub|n-1+i-j><big|.>
    </equation*>

    <tabular*|<tformat|<twith|table-width|1par>|<cwith|1|1|1|-1|cell-valign|c>|<table|<row|<cell|<image|midprod.ps|0.5w|0.5h||>>|<cell|<math|<tabular|<tformat|<cwith|1|-1|1|1|cell-halign|r>|<cwith|1|-1|2|2|cell-halign|c>|<cwith|1|1|1|1|cell-row-span|1>|<cwith|1|1|1|1|cell-col-span|3>|<cwith|1|1|1|1|cell-halign|c>|<cwith|1|1|1|1|cell-lborder|0.5ln>|<cwith|1|1|1|1|cell-rborder|0.5ln>|<cwith|1|1|1|1|cell-bborder|0.5ln>|<cwith|1|1|1|1|cell-tborder|0.5ln>|<cwith|1|1|1|1|cell-background|pastel
    green>|<cwith|2|2|1|-1|cell-tsep|0.5fn>|<table|<row|<cell|Case<space|1spc>n=2>|<cell|>|<cell|>>|<row|<cell|\<alpha\>>|<cell|=>|<cell|f<rsub|1>*(g<rsub|0>+g<rsub|1>)>>|<row|<cell|\<beta\>>|<cell|=>|<cell|(f<rsub|1>-f<rsub|0>)*g<rsub|1>>>|<row|<cell|\<gamma\>>|<cell|=>|<cell|f<rsub|0>*(g<rsub|1>+g<rsub|2>)>>|<row|<cell|h<rsub|0>>|<cell|=>|<cell|\<alpha\>-\<beta\>>>|<row|<cell|h<rsub|1>>|<cell|=>|<cell|\<gamma\>+\<beta\>>>>>>>>>>>>
  </hidden>|<\hidden>
    <with|font-series|bold|font-size|1.19|color|dark
    grey|<block*|<tformat|<cwith|1|-1|1|-1|cell-background|broken
    white>|<twith|table-width|1par>|<cwith|1|1|2|2|cell-hyphen|t>|<cwith|1|1|2|2|cell-bsep|1spc>|<cwith|1|1|2|2|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-lborder|0.5ln>|<cwith|1|-1|1|-1|cell-rborder|0.5ln>|<cwith|1|-1|1|-1|cell-bborder|0.5ln>|<cwith|1|-1|1|-1|cell-tborder|0.5ln>|<cwith|1|1|2|2|cell-hpart|1>|<cwith|1|1|1|1|cell-rborder|0ln>|<cwith|1|1|2|2|cell-lborder|0ln>|<cwith|1|1|2|2|cell-rborder|0ln>|<cwith|1|1|3|3|cell-lborder|0ln>|<cwith|1|1|1|1|cell-valign|c>|<cwith|1|1|3|3|cell-valign|c>|<cwith|1|1|2|2|cell-valign|c>|<cwith|1|1|1|1|cell-vcorrect|n>|<cwith|1|1|3|3|cell-vcorrect|n>|<table|<row|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu1.png|0.2w|0.2h||>>|<cell|<with|font-size|1|<with|color|brown|5.
    Relaxed multiplication with fixed series>>>|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu2.png|0.2w|0.2h||>>>>>>>

    \;

    For <em|fixed> <math|g<space|-0.4spc>=<space|-0.4spc>g<rsub|0><space|-0.2spc>+\<cdots\>+<space|-0.2spc>g<rsub|n-1>*z<rsup|n-1>>
    and <em|relaxed> <math|f<space|-0.4spc>=<space|-0.4spc>f<rsub|0><space|-0.2spc>+\<cdots\>+<space|-0.2spc>f<rsub|n-1>*z<rsup|n-1>>,
    compute the <em|relaxed> product <math|h=f*g=h<rsub|0>+\<cdots\>+h<rsub|n-1>*z<rsup|n-1>>.

    \;

    <\with|par-mode|center>
      <image|midrelax.ps|0.666667w|0.666667h||><space|1fn><image|midexample.ps|0.666667w|0.666667h||>
    </with>

    \;
  </hidden>|<\hidden>
    <with|font-series|bold|font-size|1.19|color|dark
    grey|<block*|<tformat|<cwith|1|-1|1|-1|cell-background|broken
    white>|<twith|table-width|1par>|<cwith|1|1|2|2|cell-hyphen|t>|<cwith|1|1|2|2|cell-bsep|1spc>|<cwith|1|1|2|2|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-lborder|0.5ln>|<cwith|1|-1|1|-1|cell-rborder|0.5ln>|<cwith|1|-1|1|-1|cell-bborder|0.5ln>|<cwith|1|-1|1|-1|cell-tborder|0.5ln>|<cwith|1|1|2|2|cell-hpart|1>|<cwith|1|1|1|1|cell-rborder|0ln>|<cwith|1|1|2|2|cell-lborder|0ln>|<cwith|1|1|2|2|cell-rborder|0ln>|<cwith|1|1|3|3|cell-lborder|0ln>|<cwith|1|1|1|1|cell-valign|c>|<cwith|1|1|3|3|cell-valign|c>|<cwith|1|1|2|2|cell-valign|c>|<cwith|1|1|1|1|cell-vcorrect|n>|<cwith|1|1|3|3|cell-vcorrect|n>|<table|<row|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu1.png|0.2w|0.2h||>>|<cell|<with|font-size|1|<with|color|black|Complexity
    results>>>|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu2.png|0.2w|0.2h||>>>>>>>

    \;

    <\theorem>
      There exists a (truncated) relaxed multiplication algorithm with one
      fixed argument, with the same time and space complexity as divide &
      conquer multiplication.
    </theorem>

    <\theorem>
      There exists a (truncated) relaxed multiplication algorithm with one
      fixed argument, which is twice as efficient as the standard fast
      relaxed multiplication algorithm from an asymptotic point of view.
    </theorem>
  </hidden>|<\hidden>
    <with|font-series|bold|font-size|1.19|color|dark
    grey|<block*|<tformat|<cwith|1|-1|1|-1|cell-background|broken
    white>|<twith|table-width|1par>|<cwith|1|1|2|2|cell-hyphen|t>|<cwith|1|1|2|2|cell-bsep|1spc>|<cwith|1|1|2|2|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-lborder|0.5ln>|<cwith|1|-1|1|-1|cell-rborder|0.5ln>|<cwith|1|-1|1|-1|cell-bborder|0.5ln>|<cwith|1|-1|1|-1|cell-tborder|0.5ln>|<cwith|1|1|2|2|cell-hpart|1>|<cwith|1|1|1|1|cell-rborder|0ln>|<cwith|1|1|2|2|cell-lborder|0ln>|<cwith|1|1|2|2|cell-rborder|0ln>|<cwith|1|1|3|3|cell-lborder|0ln>|<cwith|1|1|1|1|cell-valign|c>|<cwith|1|1|3|3|cell-valign|c>|<cwith|1|1|2|2|cell-valign|c>|<cwith|1|1|1|1|cell-vcorrect|n>|<cwith|1|1|3|3|cell-vcorrect|n>|<table|<row|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu1.png|0.2w|0.2h||>>|<cell|<with|font-size|1|<with|color|brown|6.
    Applications>>>|<cell|<image|$TEXMACS_PATH/misc/images/tm_gnu2.png|0.2w|0.2h||>>>>>>>

    \;

    <subsubsection*|Linear differential equations>

    Consider

    <\equation*>
      L<rsub|r>*f<rsup|(r)>+\<cdots\>+L<rsub|0>*f=0,
    </equation*>

    with <math|L<rsub|0>,\<ldots\>,L<rsub|r>\<in\>C[[z]]>,
    <math|L<rsub|r,0>=1>, and given <math|f<rsub|0>,\<ldots\>,f<rsub|r-1>>.
    Then the unique solution can be computed using the formula

    <\equation*>
      f=L<rsub|r><rsup|-1>*<big|int><above|\<ldots\>|r\<times\>><big|int>(L<rsub|r>*f<rsup|(r)>+\<cdots\>+L<rsub|0>*f)
    </equation*>

    in time <math|\<sim\>(r+1)*K(n)>.

    \;

    <subsubsection*|General implicit linear equations>
  </hidden>>
</body>

<\initial>
  <\collection>
    <associate|page-bot|5mm>
    <associate|page-even|5mm>
    <associate|page-odd|5mm>
    <associate|page-right|5mm>
    <associate|page-show-hf|true>
    <associate|page-top|5mm>
    <associate|par-hyphen|normal>
    <associate|preamble|false>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|6|?>>
    <associate|auto-10|<tuple|2|?>>
    <associate|auto-2|<tuple|6|?>>
    <associate|auto-3|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-4|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-5|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-6|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-7|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-8|<tuple|2|?>>
    <associate|auto-9|<tuple|2|?>>
    <associate|eq-fonc|<tuple|1|15>>
    <associate|toc-1|<tuple|<uninit>|2>>
    <associate|toc-10|<tuple|2|5>>
    <associate|toc-11|<tuple|2|5>>
    <associate|toc-12|<tuple|2|5>>
    <associate|toc-13|<tuple|2|5>>
    <associate|toc-14|<tuple|2|6>>
    <associate|toc-15|<tuple|2|6>>
    <associate|toc-16|<tuple|2|6>>
    <associate|toc-17|<tuple|2|7>>
    <associate|toc-18|<tuple|2|7>>
    <associate|toc-19|<tuple|2|7>>
    <associate|toc-2|<tuple|<uninit>|3>>
    <associate|toc-20|<tuple|2|7>>
    <associate|toc-21|<tuple|2|8>>
    <associate|toc-22|<tuple|2|8>>
    <associate|toc-23|<tuple|2|8>>
    <associate|toc-24|<tuple|2|8>>
    <associate|toc-25|<tuple|2|8>>
    <associate|toc-26|<tuple|2|8>>
    <associate|toc-27|<tuple|2|9>>
    <associate|toc-28|<tuple|2|9>>
    <associate|toc-29|<tuple|2|9>>
    <associate|toc-3|<tuple|<uninit>|3>>
    <associate|toc-30|<tuple|2|10>>
    <associate|toc-31|<tuple|2|10>>
    <associate|toc-32|<tuple|2|10>>
    <associate|toc-33|<tuple|2|11>>
    <associate|toc-34|<tuple|2|12>>
    <associate|toc-35|<tuple|2|13>>
    <associate|toc-36|<tuple|2|14>>
    <associate|toc-37|<tuple|2|14>>
    <associate|toc-38|<tuple|2|14>>
    <associate|toc-39|<tuple|2|15>>
    <associate|toc-4|<tuple|<uninit>|3>>
    <associate|toc-40|<tuple|2|15>>
    <associate|toc-41|<tuple|2|15>>
    <associate|toc-42|<tuple|2|15>>
    <associate|toc-43|<tuple|2|16>>
    <associate|toc-44|<tuple|2|16>>
    <associate|toc-45|<tuple|2|16>>
    <associate|toc-46|<tuple|2|17>>
    <associate|toc-47|<tuple|2|17>>
    <associate|toc-48|<tuple|2|17>>
    <associate|toc-49|<tuple|2|17>>
    <associate|toc-5|<tuple|<uninit>|3>>
    <associate|toc-50|<tuple|2|?>>
    <associate|toc-6|<tuple|<uninit>|4>>
    <associate|toc-7|<tuple|<uninit>|4>>
    <associate|toc-8|<tuple|2|4>>
    <associate|toc-9|<tuple|2|4>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <with|par-left|<quote|2tab>|Multiplication of formal power series
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1>>

      <with|par-left|<quote|2tab>|Classical multiplication algorithms
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|2tab>|Principle
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|2tab>|Implementation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|2tab>|Important consequence
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|2tab>|Application
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>

      <with|par-left|<quote|2tab>|Disadvantage
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-7>>

      <with|par-left|<quote|2tab>|Example : multiplication at order 4
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-8>>

      <with|par-left|<quote|2tab>|Linear differential equations
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-9>>

      <with|par-left|<quote|2tab>|General implicit linear equations
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-10>>
    </associate>
  </collection>
</auxiliary>